HMWKParser Class Reference

the main class to read a HanMac Word-K file More...

`#include <HMWKParser.hxx>`

Inheritance diagram for HMWKParser:

## Public Member Functions

| HMWKParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~HMWKParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
Vec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | sendText (long id, long subId=0)
| send a text zone (not implemented) More...
bool | sendZone (long zId)
| send a zone More...
bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern More...
bool | readZonesList ()
| try to read the zones list More...
bool | readZone (shared_ptr< HMWKZone > zone)
| try to read a generic zone More...
shared_ptr< HMWKZone > | decodeZone (shared_ptr< HMWKZone > zone)
| try to decode a zone More...
bool | readFramesUnkn (shared_ptr< HMWKZone > zone)
| try to read a zone storing a list of ?, frameType More...
bool | readPrintInfo (HMWKZone &zone)
| try to read a printinfo zone (type 7) More...
bool | readZone6 (shared_ptr< HMWKZone > zone)
| try to read a unknown zone of type 6 More...
bool | readZone8 (shared_ptr< HMWKZone > zone)
| try to read a unknown zone of type 8 More...
bool | readZonea (shared_ptr< HMWKZone > zone)
| try to read a unknown zone of type a More...
bool | readZoneb (HMWKZone &zone)
| try to read a unknown zone of type b More...
bool | readZonec (shared_ptr< HMWKZone > zone)
| try to read a unknown zone of type c More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < HMWKParserInternal::State > | m_state
| the state More...
shared_ptr< HMWKGraph > | m_graphParser
| the graph parser More...
shared_ptr< HMWKText > | m_textParser
| the text parser More...

## Friends

class | HMWKGraph
class | HMWKText
class | HMWKParserInternal::SubDocument

## Detailed Description

the main class to read a HanMac Word-K file

## Constructor & Destructor Documentation

HMWKParser::HMWKParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

HMWKParser::~HMWKParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool HMWKParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void HMWKParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool HMWKParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

shared_ptr< HMWKZone > HMWKParser::decodeZone | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to decode a zone

Referenced by readZone().

bool HMWKParser::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color
| ) |  | const

protected

returns the color associated with a pattern

Referenced by HMWKText::readFont(), and HMWKText::readParagraph().

Vec2f HMWKParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

void HMWKParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by HMWKParser().

void HMWKParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by HMWKText::sendText().

void HMWKParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool HMWKParser::readFramesUnkn | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a zone storing a list of ?, frameType

Referenced by readZone().

bool HMWKParser::readPrintInfo | ( | HMWKZone & | zone | ) |

protected

try to read a printinfo zone (type 7)

Referenced by readZone().

bool HMWKParser::readZone | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a generic zone

type1: text, type7: printInfo: typed: graphic

Referenced by createZones().

bool HMWKParser::readZone6 | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a unknown zone of type 6

Referenced by readZone().

bool HMWKParser::readZone8 | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a unknown zone of type 8

Referenced by readZone().

bool HMWKParser::readZonea | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a unknown zone of type a

Referenced by readZone().

bool HMWKParser::readZoneb | ( | HMWKZone & | zone | ) |

protected

try to read a unknown zone of type b

Referenced by readZone().

bool HMWKParser::readZonec | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a unknown zone of type c

Referenced by readZone().

bool HMWKParser::readZonesList | ( |  | ) |

protected

try to read the zones list

Referenced by createZones().

bool HMWKParser::sendText | ( | long | id,
|  | long | subId = `0`
| ) |  |

protected

send a text zone (not implemented)

Referenced by HMWKGraph::sendText().

bool HMWKParser::sendZone | ( | long | zId | ) |

protected

send a zone

Referenced by HMWKText::sendText().

## Friends And Related Function Documentation

friend class HMWKGraph

friend

Referenced by init().

friend class HMWKParserInternal::SubDocument

friend

friend class HMWKText

friend

Referenced by init().

## Member Data Documentation

shared_ptr<HMWKGraph> HMWKParser::m_graphParser

protected

the graph parser

Referenced by createDocument(), createZones(), getColor(), init(), parse(), readZone(), and sendZone().

shared_ptr<HMWKParserInternal::State> HMWKParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), init(), newPage(), and readZonesList().

shared_ptr<HMWKText> HMWKParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), readZone(), and sendText().

The documentation for this class was generated from the following files:

- HMWKParser.hxx
- HMWKParser.cxx